﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.85
@EndOfDesignText@
#Region Shared Files
'#CustomBuildAction: folders ready, %WINDIR%\System32\Robocopy.exe,"..\..\Shared Files" "..\Files"
'Ctrl + click to sync files: ide://run?file=%WINDIR%\System32\Robocopy.exe&args=..\..\Shared+Files&args=..\Files&FilesSync=True
#End Region

'Ctrl + click to export as zip: ide://run?File=%B4X%\Zipper.jar&Args=Project.zip
Sub Class_Globals
	Private Root As B4XView
	Private xui As XUI
	Private bc,bc1 As BitmapCreator
	Dim nativeMe As JavaObject
	Dim bm1, bm2 As Bitmap
	Private ImageView1, ImageView2 As ImageView
	Private anchopantalla, altopantalla As Int
	Private matr As MatrixOp
End Sub

Public Sub Initialize
End Sub

Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	Root.LoadLayout("main")
	Root.Color=Colors.LightGray
	nativeMe.InitializeContext
	
	
	Dim img As B4XBitmap = LoadBitmap(File.DirAssets, "33rfn.png")
	anchopantalla=img.Width '498
	altopantalla=img.Height '382
	bc.Initialize(anchopantalla, altopantalla)
	bc1.Initialize(anchopantalla, altopantalla)
	bc.CopyPixelsFromBitmap(img)
	'bc.DrawCircle(146,5,4,Colors.Red,True,1)
	'bc.DrawCircle(493,161,4,Colors.Red,True,1)
	'bc.DrawCircle(372,377,4,Colors.Red,True,1)
	'bc.DrawCircle(3,203,4,Colors.Red,True,1)
	bc.DrawCircle(250,150,4,Colors.Red,True,1) 'DRAW POINT RED
	bc.DrawCircle(300,200,4,Colors.blue,True,1) 'DRAW POINT RED
	bm1=bc.Bitmap
	ImageView1.Bitmap=bm1
	ImageView1.SetLayout(0,0,100%x,50%y)


	'PROCESS TRANSFORMATION ALL IMAGE FROM JAVA + CROP + RESIZE IMAGE TO FIT 
	Dim source() As Float = Array As Float(144.0, 1.0, 499.0, 160.0, 373.0, 385.0, 0.0, 210.0)
	'Dim destination() As Float = Array As Float(0, 0, 498, 0, 498, 382, 0, 382)
	Dim destination() As Float = Array As Float(0, 0, anchopantalla, 0, anchopantalla, altopantalla, 0, altopantalla)
	bm2 = nativeMe.RunMethod("perspectiveTransformationCropAndFit", Array(bm1, source, destination))
	bc1.CopyPixelsFromBitmap(bm2)


	'DRAW POINTS CORNERS CORRECTS
	Dim ToXY() As Int
	ToXY = Array As Int(146, 5)
	Dim FroXY() As Int = calculate_prespective(source, destination, ToXY)
	Log("LEFTTOP: " & TAB & ToXY(0) & TAB & ToXY(1) & TAB & FroXY(0) & TAB & FroXY(1))
	bc1.DrawCircle(FroXY(0),FroXY(1),6,Colors.Green,True,1)

	ToXY = Array As Int(493,161)
	Dim FroXY() As Int = calculate_prespective(source, destination, ToXY)
	Log("RIGHTTOP: " & TAB & ToXY(0) & TAB & ToXY(1) & TAB & FroXY(0) & TAB & FroXY(1))
	bc1.DrawCircle(FroXY(0),FroXY(1),6,Colors.Green,True,1)

	ToXY = Array As Int(372,377)
	Dim FroXY() As Int = calculate_prespective(source, destination, ToXY)
	Log("RIGHTBOTTOM: " & TAB & ToXY(0) & TAB & ToXY(1) & TAB & FroXY(0) & TAB & FroXY(1))
	bc1.DrawCircle(FroXY(0),FroXY(1),6,Colors.Green,True,1)

	ToXY = Array As Int(5,203)
	Dim FroXY() As Int = calculate_prespective(source, destination, ToXY)
	Log("LEFTBOTTOM: " & TAB & ToXY(0) & TAB & ToXY(1) & TAB & FroXY(0) & TAB & FroXY(1))
	bc1.DrawCircle(FroXY(0),FroXY(1),6,Colors.Green,True,1)


	'DRAW POINTS DESTINATION CORRECTS
	ToXY = Array As Int(250, 150)
	Dim FromXY() As Int = calculate_prespective(source, destination, ToXY)
	Log("MAGENTA: " & TAB & ToXY(0) & TAB & ToXY(1) & TAB & FromXY(0) & TAB & FromXY(1))
	bc1.DrawCircle(FromXY(0),FromXY(1),4,Colors.Magenta,True,1)
	
	ToXY = Array As Int(300, 200)
	Dim FroXY() As Int = calculate_prespective(source, destination, ToXY)
	Log("CYAN: " & TAB & ToXY(0) & TAB & ToXY(1) & TAB & FroXY(0) & TAB & FroXY(1))
	bc1.DrawCircle(FroXY(0),FroXY(1),4,Colors.Cyan,True,1)

	ImageView2.Bitmap=bc1.Bitmap
	ImageView2.SetLayout(0,50%y,100%x,50%y)
End Sub



public Sub calculate_prespective(src() As Float, dst() As Float, dstxy() As Int) As Int()
	'distorted reference points
	Dim xd(5) As Float
	xd(1) = src(0)
	xd(2) = src(2)
	xd(3) = src(4)
	xd(4) = src(6)
	Dim yd(5) As Float
	yd(1) = src(1)
	yd(2) = src(3)
	yd(3) = src(5)
	yd(4) = src(7)
	
	'unidistorted points
	Dim xu(5) As Float
	xu(1) = dst(0) '1600+200
	xu(2) = dst(2) '1600+200
	xu(3) = dst(4) '1000+200
	xu(4) = dst(6) '1000+200
	Dim yu(5) As Float
	yu(1) = dst(1) '0
	yu(2) = dst(3) '1000
	yu(3) = dst(5) '1000
	yu(4) = dst(7) '0
	
	'solve 8 equaciones lineales syste : A * k = b -> k = inv(A) * b
	Dim matrix(8,8) As Double
	Dim valoresfila1() As Float = Array As Float(	xd(1),	yd(1), 	1,	0,    	0,     	0, 	(xd(1)*-1)*xu(1), 	(yd(1)*-1)*xu(1) )
	For columna=0 To 7
		matrix(0, columna) = valoresfila1(columna)
	Next
	Dim valoresfila1() As Float = Array As Float(	0,		0,     	0, 	xd(1),	yd(1), 	1, 	(xd(1)*-1)*yu(1), 	(yd(1)*-1)*yu(1) )
	For columna=0 To 7
		matrix(1, columna) = valoresfila1(columna)
	Next
	Dim valoresfila1() As Float = Array As Float(	xd(2), 	yd(2),	1,	0,		0,		0,	(xd(2)*-1)*xu(2),	(yd(2)*-1)*xu(2) )
	For columna=0 To 7
		matrix(2, columna) = valoresfila1(columna)
	Next
	Dim valoresfila1() As Float = Array As Float(	0,		0,		0,	xd(2),	yd(2), 	1,	(xd(2)*-1)*yu(2),	(yd(2)*-1)*yu(2) )
	For columna=0 To 7
		matrix(3, columna) = valoresfila1(columna)
	Next
	Dim valoresfila1() As Float = Array As Float(	xd(3),	yd(3),	1,	0,		0,		0,	(xd(3)*-1)*xu(3),	(yd(3)*-1)*xu(3) )
	For columna=0 To 7
		matrix(4, columna) = valoresfila1(columna)
	Next
	Dim valoresfila1() As Float = Array As Float(	0,		0,		0,	xd(3),	yd(3),	1,	(xd(3)*-1)*yu(3),	(yd(3)*-1)*yu(3) )
	For columna=0 To 7
		matrix(5, columna) = valoresfila1(columna)
	Next
	Dim valoresfila1() As Float = Array As Float(	xd(4),	yd(4),	1,	0,		0,		0,	(xd(4)*-1)*xu(4),	(yd(4)*-1)*xu(4) )
	For columna=0 To 7
		matrix(6, columna) = valoresfila1(columna)
	Next
	Dim valoresfila1() As Float = Array As Float(	0,		0,		0,	xd(4),	yd(4),	1,	(xd(4)*-1)*yu(4),	(yd(4)*-1)*yu(4) )
	For columna=0 To 7
		matrix(7, columna) = valoresfila1(columna)
	Next

	Dim b() As Double
	b = Array As Double( xu(1),	yu(1), xu(2), yu(2), xu(3), yu(3), xu(4), yu(4) )
	Dim k(8) As Double
	matr.SolveV(8, matrix, b, k)

	Dim xdest As Float = dstxy(0) 'destination x
	Dim ydest As Float = dstxy(1) 'destination y
	Dim xur,yur As Float
	xur = (k(0)*xdest+k(1)*ydest+k(2)) / (k(6)*xdest+k(7)*ydest+1)
	yur = (k(3)*xdest+k(4)*ydest+k(5)) / (k(6)*xdest+k(7)*ydest+1)
	Return Array As Int(xur, yur)
End Sub